#include "StdAfx.h"
#include "MusicFile.h"

//==============================================================
//		RXgN^
//--------------------------------------------------------------
//	
//		MMLfile* MML	llkt@C̃IuWFNg
//	Ԓl
//				
//==============================================================
MusicFile::MusicFile(MMLfile* MML, string _code, const char _strName[]):
	MusicItem(_strName),
	cDPCMinfo(NULL),
	Header(MML, _code)
{
	//----------------------
	//Localϐ


//	萔`
enum	Command_ID_MusicFile {
	//for NSF output
	id_Title,
	id_Composer,
	id_Copyright,
	id_OffsetPCM,
	id_Code,

	//for ASM output
	id_SegmentSEQ,
	id_SegmentPCM,
	id_Label,

	//General
	id_include,
	id_OctaveReverse,
	id_bgm_num,
	id_se_num,

	//Block
	id_DPCM,
	id_VRC7,
	id_N163,
	id_Envelop,
	id_Macro,
	id_Sub,
	id_BGM,
	id_SE
};

//	́AMML\ŎgR}hB
const	static	Command_Info	Command[] = {
		//for NSF output
		{	"#Title",			id_Title		},
		{	"#title",			id_Title		},
		{	"#Composer",		id_Composer		},
		{	"#composer",		id_Composer		},
		{	"#Copyright",		id_Copyright	},
		{	"#copyright",		id_Copyright	},
		{	"#OffsetPCM",		id_OffsetPCM	},	//Offset Address of PCM
		{	"#offsetPCM",		id_OffsetPCM	},	//Offset Address of PCM
		{	"#Code",			id_Code			},
		{	"#code",			id_Code			},
		//for ASM output
		{	"#Segment",			id_SegmentSEQ	},	//Segment name for Sequence
		{	"#segment",			id_SegmentSEQ	},
		{	"#SegmentSEQ",		id_SegmentSEQ	},	//Segment name for Sequence
		{	"#segmentSEQ",		id_SegmentSEQ	},
		{	"#SegmentPCM",		id_SegmentPCM	},	//Segment name for PCM
		{	"#segmentPCM",		id_SegmentPCM	},
		{	"#Label",			id_Label		},
		{	"#label",			id_Label		},
		//General
		{	"#Include",			id_include		},
		{	"#include",			id_include		},
		{	"#OctaveReverse",	id_OctaveReverse},
		{	"#octaveReverse",	id_OctaveReverse},
		{	"#BGM",				id_bgm_num		},
		{	"#bgm",				id_bgm_num		},
		{	"#SE",				id_se_num		},
		{	"#se",				id_se_num		},
		//Block
		{	"DPCM",				id_DPCM			},
		{	"VRC7",				id_VRC7			},
		{	"N163",				id_N163			},
		{	"Envelope",			id_Envelop		},
		{	"envelope",			id_Envelop		},
		{	"Envelop",			id_Envelop		},
		{	"envelop",			id_Envelop		},
		{	"E",				id_Envelop		},
		{	"$",				id_Macro		},
		{	"Sub",				id_Sub			},
		{	"sub",				id_Sub			},
		{	"BGM",				id_BGM			},
		{	"bgm",				id_BGM			},
		{	"SE",				id_SE			},
		{	"se",				id_SE			},
	};

	unsigned	int			i;
	unsigned	char		cData;
				VRC7*		_vrc7;
				N163*		_n163;
				Envelop*	_env;
				BGM*		_bgm;
				SE*			_se;
				Sub*		_sub;
	string		msg;

	map<	int,	Envelop*	>::iterator	itEnvelop;
	map<	int,	BGM*		>::iterator	itBGM;
	map<	int,	SE*			>::iterator	itSE;
	map<	int,	Sub*		>::iterator	itSub;

	iSize = 0;

	do{
		
		//Pǂݍ݁iRg`FbNAincludet@C̏I[`FbNj
		cData = MML->GetChar();

		//[EOF]`FbN
		if( MML->eom() ){
			break;
		}

		//P߂
		MML->StreamPointerAdd(-1);

		//R}h̃`FbN
		switch(MML->GetCommandID(Command, sizeof(Command)/sizeof(Command_Info))){
			//for NSF output
			case(id_Code):
				Header.Set_RomCode(MML);
				break;
			case(id_Title):
				Header.Set_Title(MML);
				break;
			case(id_Composer):
				Header.Set_Composer(MML);
				break;
			case(id_Copyright):
				Header.Set_Copyright(MML);
				break;
			case(id_OffsetPCM):
				Header.Set_OffsetPCM(MML);
				break;
			//for ASM output
			case(id_SegmentSEQ):
				Header.Set_SegmentSEQ(MML);
				break;
			case(id_SegmentPCM):
				Header.Set_SegmentPCM(MML);
				break;
			case(id_Label):
				Header.Set_Label(MML);
				break;
			//General
			case(id_include):
				MML->include();
				break;
			case(id_OctaveReverse):
				MML->octave_reverse = true;		//́AMMLt@C̑B
				break;
			case(id_bgm_num):
				Header.Set_Number_BGM(MML);
				break;
			case(id_se_num):
				Header.Set_Number_SE(MML);
				break;
			//MML
			case(id_DPCM):
				if(cDPCMinfo != NULL){
					MML->Err("DPCMubN͂P܂łłB");
				}
				cDPCMinfo = new DPCMinfo(MML);
				ptcItem.push_back(cDPCMinfo);
				iSize += cDPCMinfo->getSize();	//BGM̃TCYXV
				break;
			case(id_VRC7):
				i = MML->GetNum();

				//d`FbN
				if(ptcVRC7.count(i) != 0){
					MML->Err("VRC7()ubNœԍw肳܂B");
				}
				_vrc7 = new VRC7(MML, i);
				ptcItem.push_back(_vrc7);
				ptcVRC7[i] = _vrc7;
				iSize += _vrc7->getSize();	//BGM̃TCYXV
				break;
			case(id_N163):
				i = MML->GetNum();

				//d`FbN
				if(ptcN163.count(i) != 0){
					MML->Err("N163()ubNœԍw肳܂B");
				}
				_n163 = new N163(MML, i);
				ptcItem.push_back(_n163);
				ptcN163[i] = _n163;
				iSize += _n163->getSize();	//BGM̃TCYXV
				break;
			case(id_Envelop):
				i = MML->GetNum();
				//d`FbN
				if(ptcEnv.count(i) != 0){
					MML->Err("Envelop()ubNœԍw肳܂B");
				}
				_env = new Envelop(MML, i);
				ptcItem.push_back(_env);
				ptcEnv[i] = _env;
				iSize += _env->getSize();	//BGM̃TCYXV
				break;
			case(id_Macro):
				//@to do
				break;
			case(id_Sub):
				i = MML->GetNum();
				//d`FbN
				if(ptcSub.count(i) != 0){
					MML->Err("Sub()ubNœԍw肳܂B");
				}
				//͈̓`FbN
				_sub = new Sub(MML, i);
				ptcItem.push_back(_sub);
				ptcSub[i] = _sub;
				iSize += _sub->getSize();	//BGM̃TCYXV
				break;
			case(id_BGM):
				i = MML->GetNum();
				//d`FbN
				if(ptcBGM.count(i) != 0){
					MML->Err("BGM()ubNœԍw肳܂B");
				}
				//͈̓`FbN
				if((Header.iBGM <= i) || (i<0)){
					MML->Err("BGM()ubNŎwł͈͂𒴂Ă܂B\n#BGM̐lmFĂB");
				}
				_bgm = new BGM(MML, i);
				ptcItem.push_back(_bgm);
				ptcBGM[i] = _bgm;
				iSize += _bgm->getSize();	//BGM̃TCYXV
				break;
			case(id_SE):
				i = MML->GetNum();
				//d`FbN
				if(ptcSE.count(i) != 0){
					MML->Err("SE()ubNœԍw肳܂B");
				}
				//͈̓`FbN
				if((Header.iSE <= i) || (i<0)){
					MML->Err("SE()ubNŎwł͈͂𒴂Ă܂B\n#SE̐lmFĂB");
				}
				_se = new SE(MML, i);
				ptcItem.push_back(_se);
				ptcSE[i] = _se;
				iSize += _se->getSize();	//BGM̃TCYXV
				break;
			default:
				MML->Err("unknown command");
				break;
		}
		
	} while( !MML->eom() );

	//Check
	if( Header.iBGM + Header.iSE > 255){
		Err("BGMSE̐Av255z܂B");
	}

	i = 0;
	while(i < Header.iBGM){
		if(ptcBGM.count(i) == 0){
			Err("BGMf[^܂B");
		};
		i++;
	}

	i = 0;
	while(i < Header.iSE){
		if(ptcSE.count(i) == 0){
			Err("SE f[^܂B");
		};
		i++;
	}

}

//==============================================================
//		fXgN^
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
MusicFile::~MusicFile(void)
{
}

//==============================================================
//		PCM̃ItZbgAhXvZ
//--------------------------------------------------------------
//	
//				
//	Ԓl
//		unsigned	int	PCM̍vTCY
//==============================================================
unsigned	int		MusicFile::SetDPCMOffset(void)
{
	unsigned	int	i;

	dpcm_code.clear();
	if(cDPCMinfo != NULL){
		cDPCMinfo->getDPCMCode(&dpcm_code);
		i = cDPCMinfo->setDPCMoffset(Header.offsetPCM);
	} else {
		i = Header.offsetPCM;
	}
	return(i - Header.offsetPCM);
}

//==============================================================
//		AhX肷B
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
void	MusicFile::Fix_Address(void)
{
	map<int,Sub*	>::iterator	itSub;

	unsigned	int			iBGM	= 0;
	unsigned	int			iSE		= 0;

	while(iBGM < Header.iBGM){
		ptcBGM[iBGM]->Fix_Address(this);
		iBGM++;
	}
	while(iSE < Header.iSE){
		ptcSE[iSE]->Fix_Address(this);
		iSE++;
	}

	if(!ptcSub.empty()){
		itSub = ptcSub.begin();
		while(itSub != ptcSub.end()){
			itSub->second->Fix_Address(this);
			itSub++;
		}
	}
}

/*
//==============================================================
//		ȃoCiC[W̍쐬
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
void	MusicFile::make_binary(void)
{

}
*/		
//==============================================================
//		mre̍쐬
//--------------------------------------------------------------
//	
//		const char*	strFileName	R[h
//	Ԓl
//				
//==============================================================
void	MusicFile::make_bin(unsigned int rom_size)
{
				string		_str;
	unsigned	int			i		= 2;
	unsigned	int			iBGM	= 0;
	unsigned	int			iSE		= 0;
	unsigned	__int16*	pt;

	unsigned	int			_size	= 4 + (Header.iBGM + Header.iSE)*2;


	//ȃoCi[̍쐬
	_str.clear();
	_str.resize(_size);

	pt = (unsigned __int16*)_str.c_str();

	_str[0] = Header.iBGM;
	_str[1] = Header.iSE;

	if(cDPCMinfo != NULL){
		pt[1]	= 0x8000 + rom_size - 0x80 + _size + cDPCMinfo->getOffset();	//PCM info ̃AhX
	} else {
		pt[1]	= 0;
	}

	while(iBGM < Header.iBGM){
		pt[i] = 0x8000 + rom_size - 0x80 + _size + ptcBGM[iBGM]->getOffset();
		i++;
		iBGM++;
	}
	while(iSE < Header.iSE){
		pt[i] = 0x8000 + rom_size - 0x80 + _size + ptcSE[iSE]->getOffset();
		i++;
		iSE++;
	}

	getCode(&_str);
	code = _str;

	//PCM̍쐬
	dpcm_code.clear();
	if(cDPCMinfo != NULL){
		cDPCMinfo->getDPCMCode(&dpcm_code);
	}

}

//==============================================================
//		mre`ւ̕ۑ
//--------------------------------------------------------------
//	
//		const char*	strFileName		t@C
//	Ԓl
//				
//==============================================================
void	MusicFile::saveNSF(const char*	strFileName,bool opt)
{

	unsigned	int		i,j;
	unsigned	int		bin_size;
	unsigned	int		mus_size;
	unsigned	int		pcm_size;
	unsigned	char	mus_bank;
	unsigned	char	pcm_bank;
				char*	romimg		= new char[0x8000+0x80];
	NSF_Header*			nsf			= (NSF_Header*)romimg;
	FileInput*			_romcode	= new FileInput();




	//NSFpR[h̓]
	_romcode->fileopen(Header.romcode.c_str());
	bin_size = _romcode->GetSize();
	_romcode->read(romimg, bin_size);
	_romcode->close();
	delete		_romcode;

	//V[PX̃oCi𐶐
	make_bin(bin_size);

	mus_size = bin_size - 0x80 + code.size();
	if(opt == true){
		mus_bank = mus_size >> 12;
		if((mus_size & 0x0FFF) != 0){
			mus_bank++;
		}
	} else {
		mus_bank = (Header.offsetPCM - 0x8000) >> 12; 
	}


	//TCY`FbN
	if((0x8000 + mus_size) > Header.offsetPCM){
		cout << "R[hEV[PX̃TCYelz܂B" << endl;
		cout << "@elF" << Header.offsetPCM - 0x8000 << "[Byte]" << endl;
		cout << "@TCYF" << mus_size << "[Byte]" << endl;
		exit(-1);
	}

	//PCM
	pcm_size = dpcm_code.size();
	pcm_bank = pcm_size >> 12;
	if((pcm_size & 0x0FFF) != 0){
		pcm_bank++;
	}
	//PCMTCY`FbN
	if(	(Header.offsetPCM + pcm_size) > 0x10000	){
		cout << "PCM̃TCYelz܂B" << endl;
		cout << "@elF" << 0x10000 - Header.offsetPCM << "[Byte]" << endl;
		cout << "@TCYF" << pcm_size << "[Byte]" << endl;
		exit(-1);
	}

	//NSFwb_[̍XV
	nsf->MusicNumber		= Header.iBGM + Header.iSE;
	memcpy(&nsf->Title, Header.title.c_str(), 32);
	memcpy(&nsf->Composer, Header.composer.c_str(), 32);
	memcpy(&nsf->Copyright, Header.copyright.c_str(), 32);

	//----------------------
	//mre
	fileopen(strFileName);

	if(cDPCMinfo == NULL){
		write(romimg, bin_size);			//NSFwb_[  R[h̏
		write(code.c_str(), code.size());	//V[PX̏
	//	//0 padding
	//	while(mus_size < ((unsigned int)mus_bank<<12)){
	//		put(0);		//0 padding
	//		mus_size++;
	//	}
	} else {
		//wb_[ɃoNB
		if(opt == true){
			i = 0;
			while(i < mus_bank){
				nsf->Bank[i] = i;
				i++;
			}
			while(i < ((Header.offsetPCM - 0x8000)>>12)){
				nsf->Bank[i] = 0;
				i++;
			}
			j = 0;
			while(i < 8){
				if(j < pcm_bank){
					nsf->Bank[i] = mus_bank + j;
				} else {
					nsf->Bank[i] = 0;
				}
				i++;
				j++;
			}
		}
		//R[hV[PX
		write(romimg, bin_size);			//NSFwb_[  R[h̏
		write(code.c_str(), code.size());	//V[PX̏
		while(mus_size < ((unsigned int)mus_bank<<12)){
			put(0);		//0 padding
			mus_size++;
		}
		//PCM
		write(dpcm_code.c_str(), pcm_size);		//PCM̏
		if(opt == true){
			while(pcm_size < ((unsigned int)pcm_bank<<12)){
				put(0);		//0 padding
				pcm_size++;
			}
		}
	}

	close();

	//----------------------
	//Exit
	delete[]	romimg;
}

//==============================================================
//		AZu\[Xւ̕ۑ
//--------------------------------------------------------------
//	
//		const char*	strFileName		t@C
//	Ԓl
//				
//==============================================================
void	MusicFile::saveASM(const char*	strFileName)
{
	unsigned	int			iBGM	= 0;
	unsigned	int			iSE		= 0;

	//----------------------
	//File open
	fileopen(strFileName);

	//Header
	*this <<	";===============================================================\n"
				";		Music file for NES Sound Driver & Library\n"
				";			for assembly language (ca65.exe)\n"
				";===============================================================\n"
				<<endl;

	//Export of Sequence
	while(iBGM < Header.iBGM){
		*this	<<	"	.export		"	<<	Header.Label	<<	"BGM"	<<	iBGM	<<	endl;
		iBGM++;
	}
	while(iSE < Header.iSE){
		*this	<<	"	.export		"	<<	Header.Label	<<	"SE"	<<	iSE	<<	endl;
		iSE++;
	}

	if(cDPCMinfo != NULL){
		*this	<<	"	.export		"	<<	Header.Label	<<	"DPCMinfo"	<<	endl;
	}

	//MML
	*this <<	"\n\n.segment	"	<<	'"'	<<	Header.segmentSEQ	<<	'"' << endl;

	getAsm(this);

	//----------------------
	//Close file
	close();
}

//==============================================================
//		G[
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
void	MusicFile::Err(const char* msg)
{
	cout << "[ ERROR ] : " << msg << endl;

	//ُI
	exit(-1);
}

//==============================================================
//		[jO
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
void	MusicFile::Warning(const char* msg)
{
	//݂̃t@CƁAs\
	cout << "[WARNING] : " << msg << endl;
}
